signature DeflateIO =
sig

	(*
	 bit/byte in/out stream
	*)
	
	type byteio
	
	(* constructor *)
	
	val from_input : DeflateBits.byte list -> byteio
	
	val from_input_string : string -> byteio
	
	(* debug *)
	
	val to_string : byteio -> string
	
	(* output *)
	
	val output : byteio -> DeflateBits.byte list
	
	val output_string : byteio -> string
	
	val append_from_output : byteio -> int -> int -> byteio
	
	val append_byte : byteio -> DeflateBits.byte -> byteio
	
	val append_bytes : byteio -> DeflateBits.byte list -> byteio
	
	(* take and drop bits from input *)
	
	val take_bytes : byteio -> int -> DeflateBits.byte list
	
	val drop_bytes : byteio -> int -> byteio
	
	val take_zero_string : byteio -> string
	
	val drop_zero_string : byteio -> byteio
	
	val take_bit : byteio -> bool
	
	val drop_bit : byteio -> byteio
	
	val take_bits : byteio -> int -> bool list
	
	val drop_bits : byteio -> int -> byteio
	
	val drop_to_byte : byteio -> byteio
	
	val take_fixed : byteio -> int -> int
	
	val get_fixed : int -> byteio -> int * byteio
		
	(* self test *)
	val tests: bool list  
	 
end
